/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-21 15:27:30 UTC)
 * on 2013-08-29 at 01:09:00 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.plus;

/**
 * Service definition for Plus (v1domains).
 *
 * <p>
 * The Google+ API enables developers to build on top of the Google+ platform.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/+/api/" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link PlusRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Plus extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    com.google.api.client.util.Preconditions.checkState(
        com.google.api.client.googleapis.GoogleUtils.MAJOR_VERSION == 1 &&
        com.google.api.client.googleapis.GoogleUtils.MINOR_VERSION >= 15,
        "You are currently running with version %s of google-api-client. " +
        "You need at least version 1.15 of google-api-client to run version " +
        "1.16.0-rc of the Google+ API library.", com.google.api.client.googleapis.GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "plus/v1domains/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   */
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport, which should normally be:
   *        <ul>
   *        <li>Google App Engine:
   *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
   *        <li>Android: {@code newCompatibleTransport} from
   *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
   *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
   *        </li>
   *        </ul>
   * @param jsonFactory JSON factory, which may be:
   *        <ul>
   *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
   *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
   *        <li>Android Honeycomb or higher:
   *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
   *        </ul>
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Plus(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
      com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
    this(new Builder(transport, jsonFactory, httpRequestInitializer));
  }

  /**
   * @param builder builder
   */
  Plus(Builder builder) {
    super(builder);
  }

  @Override
  protected void initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Activities collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Plus plus = new Plus(...);}
   *   {@code Plus.Activities.List request = plus.activities().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Activities activities() {
    return new Activities();
  }

  /**
   * The "activities" collection of methods.
   */
  public class Activities {

    /**
     * Get an activity.
     *
     * Create a request for the method "activities.get".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param activityId The ID of the activity to get.
     * @return the request
     */
    public Get get(java.lang.String activityId) throws java.io.IOException {
      Get result = new Get(activityId);
      initialize(result);
      return result;
    }

    public class Get extends PlusRequest<com.google.api.services.plus.model.Activity> {

      private static final String REST_PATH = "activities/{activityId}";

      /**
       * Get an activity.
       *
       * Create a request for the method "activities.get".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param activityId The ID of the activity to get.
       * @since 1.13
       */
      protected Get(java.lang.String activityId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.Activity.class);
        this.activityId = com.google.api.client.util.Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(java.lang.String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(java.lang.String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(java.lang.String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(java.lang.String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(java.lang.String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(java.lang.String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the activity to get. */
      @com.google.api.client.util.Key
      private java.lang.String activityId;

      /** The ID of the activity to get.
       */
      public java.lang.String getActivityId() {
        return activityId;
      }

      /** The ID of the activity to get. */
      public Get setActivityId(java.lang.String activityId) {
        this.activityId = activityId;
        return this;
      }

      @Override
      public Get set(String parameterName, Object value) {
        return (Get) super.set(parameterName, value);
      }
    }
    /**
     * Create a new activity for the authenticated user.
     *
     * Create a request for the method "activities.insert".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user to create the activity on behalf of. Its value should be "me", to indicate the
     *        authenticated user.
     * @param content the {@link com.google.api.services.plus.model.Activity}
     * @return the request
     */
    public Insert insert(java.lang.String userId, com.google.api.services.plus.model.Activity content) throws java.io.IOException {
      Insert result = new Insert(userId, content);
      initialize(result);
      return result;
    }

    public class Insert extends PlusRequest<com.google.api.services.plus.model.Activity> {

      private static final String REST_PATH = "people/{userId}/activities";

      /**
       * Create a new activity for the authenticated user.
       *
       * Create a request for the method "activities.insert".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user to create the activity on behalf of. Its value should be "me", to indicate the
     *        authenticated user.
       * @param content the {@link com.google.api.services.plus.model.Activity}
       * @since 1.13
       */
      protected Insert(java.lang.String userId, com.google.api.services.plus.model.Activity content) {
        super(Plus.this, "POST", REST_PATH, content, com.google.api.services.plus.model.Activity.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public Insert setAlt(java.lang.String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(java.lang.String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(java.lang.String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(java.lang.String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(java.lang.String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(java.lang.String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /**
       * The ID of the user to create the activity on behalf of. Its value should be "me", to
       * indicate the authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the user to create the activity on behalf of. Its value should be "me", to indicate the
     authenticated user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * The ID of the user to create the activity on behalf of. Its value should be "me", to
       * indicate the authenticated user.
       */
      public Insert setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      /**
       * If "true", extract the potential media attachments for a URL. The response will include all
       * possible attachments for a URL, including video, photos, and articles based on the content
       * of the page.
       */
      @com.google.api.client.util.Key
      private java.lang.Boolean preview;

      /** If "true", extract the potential media attachments for a URL. The response will include all
     possible attachments for a URL, including video, photos, and articles based on the content of the
     page.
       */
      public java.lang.Boolean getPreview() {
        return preview;
      }

      /**
       * If "true", extract the potential media attachments for a URL. The response will include all
       * possible attachments for a URL, including video, photos, and articles based on the content
       * of the page.
       */
      public Insert setPreview(java.lang.Boolean preview) {
        this.preview = preview;
        return this;
      }

      @Override
      public Insert set(String parameterName, Object value) {
        return (Insert) super.set(parameterName, value);
      }
    }
    /**
     * List all of the activities in the specified collection for a particular user.
     *
     * Create a request for the method "activities.list".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user to get activities for. The special value "me" can be used to indicate the
     *        authenticated user.
     * @param collection The collection of activities to list.
     * @return the request
     */
    public List list(java.lang.String userId, java.lang.String collection) throws java.io.IOException {
      List result = new List(userId, collection);
      initialize(result);
      return result;
    }

    public class List extends PlusRequest<com.google.api.services.plus.model.ActivityFeed> {

      private static final String REST_PATH = "people/{userId}/activities/{collection}";

      /**
       * List all of the activities in the specified collection for a particular user.
       *
       * Create a request for the method "activities.list".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user to get activities for. The special value "me" can be used to indicate the
     *        authenticated user.
       * @param collection The collection of activities to list.
       * @since 1.13
       */
      protected List(java.lang.String userId, java.lang.String collection) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.ActivityFeed.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        this.collection = com.google.api.client.util.Preconditions.checkNotNull(collection, "Required parameter collection must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(java.lang.String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(java.lang.String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(java.lang.String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(java.lang.String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(java.lang.String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(java.lang.String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /**
       * The ID of the user to get activities for. The special value "me" can be used to indicate
       * the authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the user to get activities for. The special value "me" can be used to indicate the
     authenticated user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * The ID of the user to get activities for. The special value "me" can be used to indicate
       * the authenticated user.
       */
      public List setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      /** The collection of activities to list. */
      @com.google.api.client.util.Key
      private java.lang.String collection;

      /** The collection of activities to list.
       */
      public java.lang.String getCollection() {
        return collection;
      }

      /** The collection of activities to list. */
      public List setCollection(java.lang.String collection) {
        this.collection = collection;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public List setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
       * The maximum number of activities to include in the response, which is used for paging. For
       * any response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of activities to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 20]
     [minimum: 1] [maximum: 100]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of activities to include in the response, which is used for paging. For
       * any response, the actual number returned might be less than the specified maxResults.
       */
      public List setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public List set(String parameterName, Object value) {
        return (List) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the Audiences collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Plus plus = new Plus(...);}
   *   {@code Plus.Audiences.List request = plus.audiences().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Audiences audiences() {
    return new Audiences();
  }

  /**
   * The "audiences" collection of methods.
   */
  public class Audiences {

    /**
     * List all of the audiences to which a user can share.
     *
     * Create a request for the method "audiences.list".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user to get audiences for. The special value "me" can be used to indicate the
     *        authenticated user.
     * @return the request
     */
    public List list(java.lang.String userId) throws java.io.IOException {
      List result = new List(userId);
      initialize(result);
      return result;
    }

    public class List extends PlusRequest<com.google.api.services.plus.model.AudiencesFeed> {

      private static final String REST_PATH = "people/{userId}/audiences";

      /**
       * List all of the audiences to which a user can share.
       *
       * Create a request for the method "audiences.list".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user to get audiences for. The special value "me" can be used to indicate the
     *        authenticated user.
       * @since 1.13
       */
      protected List(java.lang.String userId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.AudiencesFeed.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(java.lang.String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(java.lang.String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(java.lang.String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(java.lang.String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(java.lang.String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(java.lang.String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /**
       * The ID of the user to get audiences for. The special value "me" can be used to indicate the
       * authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the user to get audiences for. The special value "me" can be used to indicate the
     authenticated user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * The ID of the user to get audiences for. The special value "me" can be used to indicate the
       * authenticated user.
       */
      public List setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public List setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
       * The maximum number of circles to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of circles to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 20]
     [minimum: 1] [maximum: 100]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of circles to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      public List setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public List set(String parameterName, Object value) {
        return (List) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the Circles collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Plus plus = new Plus(...);}
   *   {@code Plus.Circles.List request = plus.circles().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Circles circles() {
    return new Circles();
  }

  /**
   * The "circles" collection of methods.
   */
  public class Circles {

    /**
     * Add a person to a circle. Google+ limits certain circle operations, including the number of
     * circle adds. Learn More.
     *
     * Create a request for the method "circles.addPeople".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link AddPeople#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to add the person to.
     * @return the request
     */
    public AddPeople addPeople(java.lang.String circleId) throws java.io.IOException {
      AddPeople result = new AddPeople(circleId);
      initialize(result);
      return result;
    }

    public class AddPeople extends PlusRequest<com.google.api.services.plus.model.Circle> {

      private static final String REST_PATH = "circles/{circleId}/people";

      /**
       * Add a person to a circle. Google+ limits certain circle operations, including the number of
       * circle adds. Learn More.
       *
       * Create a request for the method "circles.addPeople".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link AddPeople#execute()} method to invoke the remote operation. <p>
       * {@link
       * AddPeople#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
       * must be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to add the person to.
       * @since 1.13
       */
      protected AddPeople(java.lang.String circleId) {
        super(Plus.this, "PUT", REST_PATH, null, com.google.api.services.plus.model.Circle.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public AddPeople setAlt(java.lang.String alt) {
        return (AddPeople) super.setAlt(alt);
      }

      @Override
      public AddPeople setFields(java.lang.String fields) {
        return (AddPeople) super.setFields(fields);
      }

      @Override
      public AddPeople setKey(java.lang.String key) {
        return (AddPeople) super.setKey(key);
      }

      @Override
      public AddPeople setOauthToken(java.lang.String oauthToken) {
        return (AddPeople) super.setOauthToken(oauthToken);
      }

      @Override
      public AddPeople setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (AddPeople) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public AddPeople setQuotaUser(java.lang.String quotaUser) {
        return (AddPeople) super.setQuotaUser(quotaUser);
      }

      @Override
      public AddPeople setUserIp(java.lang.String userIp) {
        return (AddPeople) super.setUserIp(userIp);
      }

      /** The ID of the circle to add the person to. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to add the person to.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to add the person to. */
      public AddPeople setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      /** IDs of the people to add to the circle. Optional, can be repeated. */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> userId;

      /** IDs of the people to add to the circle. Optional, can be repeated.
       */
      public java.util.List<java.lang.String> getUserId() {
        return userId;
      }

      /** IDs of the people to add to the circle. Optional, can be repeated. */
      public AddPeople setUserId(java.util.List<java.lang.String> userId) {
        this.userId = userId;
        return this;
      }

      /** Email of the people to add to the circle. Optional, can be repeated. */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> email;

      /** Email of the people to add to the circle. Optional, can be repeated.
       */
      public java.util.List<java.lang.String> getEmail() {
        return email;
      }

      /** Email of the people to add to the circle. Optional, can be repeated. */
      public AddPeople setEmail(java.util.List<java.lang.String> email) {
        this.email = email;
        return this;
      }

      @Override
      public AddPeople set(String parameterName, Object value) {
        return (AddPeople) super.set(parameterName, value);
      }
    }
    /**
     * Get a circle.
     *
     * Create a request for the method "circles.get".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to get.
     * @return the request
     */
    public Get get(java.lang.String circleId) throws java.io.IOException {
      Get result = new Get(circleId);
      initialize(result);
      return result;
    }

    public class Get extends PlusRequest<com.google.api.services.plus.model.Circle> {

      private static final String REST_PATH = "circles/{circleId}";

      /**
       * Get a circle.
       *
       * Create a request for the method "circles.get".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to get.
       * @since 1.13
       */
      protected Get(java.lang.String circleId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.Circle.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(java.lang.String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(java.lang.String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(java.lang.String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(java.lang.String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(java.lang.String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(java.lang.String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the circle to get. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to get.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to get. */
      public Get setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      @Override
      public Get set(String parameterName, Object value) {
        return (Get) super.set(parameterName, value);
      }
    }
    /**
     * Create a new circle for the authenticated user.
     *
     * Create a request for the method "circles.insert".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user to create the circle on behalf of. The value "me" can be used to indicate the
     *        authenticated user.
     * @param content the {@link com.google.api.services.plus.model.Circle}
     * @return the request
     */
    public Insert insert(java.lang.String userId, com.google.api.services.plus.model.Circle content) throws java.io.IOException {
      Insert result = new Insert(userId, content);
      initialize(result);
      return result;
    }

    public class Insert extends PlusRequest<com.google.api.services.plus.model.Circle> {

      private static final String REST_PATH = "people/{userId}/circles";

      /**
       * Create a new circle for the authenticated user.
       *
       * Create a request for the method "circles.insert".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user to create the circle on behalf of. The value "me" can be used to indicate the
     *        authenticated user.
       * @param content the {@link com.google.api.services.plus.model.Circle}
       * @since 1.13
       */
      protected Insert(java.lang.String userId, com.google.api.services.plus.model.Circle content) {
        super(Plus.this, "POST", REST_PATH, content, com.google.api.services.plus.model.Circle.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        checkRequiredParameter(content, "content");
        checkRequiredParameter(content.getDisplayName(), "Circle.getDisplayName()");
      }

      @Override
      public Insert setAlt(java.lang.String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(java.lang.String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(java.lang.String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(java.lang.String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(java.lang.String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(java.lang.String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /**
       * The ID of the user to create the circle on behalf of. The value "me" can be used to
       * indicate the authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the user to create the circle on behalf of. The value "me" can be used to indicate the
     authenticated user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * The ID of the user to create the circle on behalf of. The value "me" can be used to
       * indicate the authenticated user.
       */
      public Insert setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      @Override
      public Insert set(String parameterName, Object value) {
        return (Insert) super.set(parameterName, value);
      }
    }
    /**
     * List all of the circles for a user.
     *
     * Create a request for the method "circles.list".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user to get circles for. The special value "me" can be used to indicate the
     *        authenticated user.
     * @return the request
     */
    public List list(java.lang.String userId) throws java.io.IOException {
      List result = new List(userId);
      initialize(result);
      return result;
    }

    public class List extends PlusRequest<com.google.api.services.plus.model.CircleFeed> {

      private static final String REST_PATH = "people/{userId}/circles";

      /**
       * List all of the circles for a user.
       *
       * Create a request for the method "circles.list".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user to get circles for. The special value "me" can be used to indicate the
     *        authenticated user.
       * @since 1.13
       */
      protected List(java.lang.String userId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.CircleFeed.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(java.lang.String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(java.lang.String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(java.lang.String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(java.lang.String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(java.lang.String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(java.lang.String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /**
       * The ID of the user to get circles for. The special value "me" can be used to indicate the
       * authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the user to get circles for. The special value "me" can be used to indicate the
     authenticated user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * The ID of the user to get circles for. The special value "me" can be used to indicate the
       * authenticated user.
       */
      public List setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public List setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
       * The maximum number of circles to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of circles to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 20]
     [minimum: 1] [maximum: 100]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of circles to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      public List setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public List set(String parameterName, Object value) {
        return (List) super.set(parameterName, value);
      }
    }
    /**
     * Update a circle's description. This method supports patch semantics.
     *
     * Create a request for the method "circles.patch".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Patch#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to update.
     * @param content the {@link com.google.api.services.plus.model.Circle}
     * @return the request
     */
    public Patch patch(java.lang.String circleId, com.google.api.services.plus.model.Circle content) throws java.io.IOException {
      Patch result = new Patch(circleId, content);
      initialize(result);
      return result;
    }

    public class Patch extends PlusRequest<com.google.api.services.plus.model.Circle> {

      private static final String REST_PATH = "circles/{circleId}";

      /**
       * Update a circle's description. This method supports patch semantics.
       *
       * Create a request for the method "circles.patch".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Patch#execute()} method to invoke the remote operation. <p> {@link
       * Patch#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to update.
       * @param content the {@link com.google.api.services.plus.model.Circle}
       * @since 1.13
       */
      protected Patch(java.lang.String circleId, com.google.api.services.plus.model.Circle content) {
        super(Plus.this, "PATCH", REST_PATH, content, com.google.api.services.plus.model.Circle.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public Patch setAlt(java.lang.String alt) {
        return (Patch) super.setAlt(alt);
      }

      @Override
      public Patch setFields(java.lang.String fields) {
        return (Patch) super.setFields(fields);
      }

      @Override
      public Patch setKey(java.lang.String key) {
        return (Patch) super.setKey(key);
      }

      @Override
      public Patch setOauthToken(java.lang.String oauthToken) {
        return (Patch) super.setOauthToken(oauthToken);
      }

      @Override
      public Patch setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Patch) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Patch setQuotaUser(java.lang.String quotaUser) {
        return (Patch) super.setQuotaUser(quotaUser);
      }

      @Override
      public Patch setUserIp(java.lang.String userIp) {
        return (Patch) super.setUserIp(userIp);
      }

      /** The ID of the circle to update. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to update.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to update. */
      public Patch setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      @Override
      public Patch set(String parameterName, Object value) {
        return (Patch) super.set(parameterName, value);
      }
    }
    /**
     * Delete a circle.
     *
     * Create a request for the method "circles.remove".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Remove#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to delete.
     * @return the request
     */
    public Remove remove(java.lang.String circleId) throws java.io.IOException {
      Remove result = new Remove(circleId);
      initialize(result);
      return result;
    }

    public class Remove extends PlusRequest<Void> {

      private static final String REST_PATH = "circles/{circleId}";

      /**
       * Delete a circle.
       *
       * Create a request for the method "circles.remove".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Remove#execute()} method to invoke the remote operation. <p> {@link
       * Remove#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to delete.
       * @since 1.13
       */
      protected Remove(java.lang.String circleId) {
        super(Plus.this, "DELETE", REST_PATH, null, Void.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public Remove setAlt(java.lang.String alt) {
        return (Remove) super.setAlt(alt);
      }

      @Override
      public Remove setFields(java.lang.String fields) {
        return (Remove) super.setFields(fields);
      }

      @Override
      public Remove setKey(java.lang.String key) {
        return (Remove) super.setKey(key);
      }

      @Override
      public Remove setOauthToken(java.lang.String oauthToken) {
        return (Remove) super.setOauthToken(oauthToken);
      }

      @Override
      public Remove setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Remove) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Remove setQuotaUser(java.lang.String quotaUser) {
        return (Remove) super.setQuotaUser(quotaUser);
      }

      @Override
      public Remove setUserIp(java.lang.String userIp) {
        return (Remove) super.setUserIp(userIp);
      }

      /** The ID of the circle to delete. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to delete.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to delete. */
      public Remove setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      @Override
      public Remove set(String parameterName, Object value) {
        return (Remove) super.set(parameterName, value);
      }
    }
    /**
     * Remove a person from a circle.
     *
     * Create a request for the method "circles.removePeople".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link RemovePeople#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to remove the person from.
     * @return the request
     */
    public RemovePeople removePeople(java.lang.String circleId) throws java.io.IOException {
      RemovePeople result = new RemovePeople(circleId);
      initialize(result);
      return result;
    }

    public class RemovePeople extends PlusRequest<Void> {

      private static final String REST_PATH = "circles/{circleId}/people";

      /**
       * Remove a person from a circle.
       *
       * Create a request for the method "circles.removePeople".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link RemovePeople#execute()} method to invoke the remote operation. <p>
       * {@link
       * RemovePeople#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
       * must be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to remove the person from.
       * @since 1.13
       */
      protected RemovePeople(java.lang.String circleId) {
        super(Plus.this, "DELETE", REST_PATH, null, Void.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public RemovePeople setAlt(java.lang.String alt) {
        return (RemovePeople) super.setAlt(alt);
      }

      @Override
      public RemovePeople setFields(java.lang.String fields) {
        return (RemovePeople) super.setFields(fields);
      }

      @Override
      public RemovePeople setKey(java.lang.String key) {
        return (RemovePeople) super.setKey(key);
      }

      @Override
      public RemovePeople setOauthToken(java.lang.String oauthToken) {
        return (RemovePeople) super.setOauthToken(oauthToken);
      }

      @Override
      public RemovePeople setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (RemovePeople) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public RemovePeople setQuotaUser(java.lang.String quotaUser) {
        return (RemovePeople) super.setQuotaUser(quotaUser);
      }

      @Override
      public RemovePeople setUserIp(java.lang.String userIp) {
        return (RemovePeople) super.setUserIp(userIp);
      }

      /** The ID of the circle to remove the person from. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to remove the person from.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to remove the person from. */
      public RemovePeople setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      /** IDs of the people to remove from the circle. Optional, can be repeated. */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> userId;

      /** IDs of the people to remove from the circle. Optional, can be repeated.
       */
      public java.util.List<java.lang.String> getUserId() {
        return userId;
      }

      /** IDs of the people to remove from the circle. Optional, can be repeated. */
      public RemovePeople setUserId(java.util.List<java.lang.String> userId) {
        this.userId = userId;
        return this;
      }

      /** Email of the people to add to the circle. Optional, can be repeated. */
      @com.google.api.client.util.Key
      private java.util.List<java.lang.String> email;

      /** Email of the people to add to the circle. Optional, can be repeated.
       */
      public java.util.List<java.lang.String> getEmail() {
        return email;
      }

      /** Email of the people to add to the circle. Optional, can be repeated. */
      public RemovePeople setEmail(java.util.List<java.lang.String> email) {
        this.email = email;
        return this;
      }

      @Override
      public RemovePeople set(String parameterName, Object value) {
        return (RemovePeople) super.set(parameterName, value);
      }
    }
    /**
     * Update a circle's description.
     *
     * Create a request for the method "circles.update".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Update#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to update.
     * @param content the {@link com.google.api.services.plus.model.Circle}
     * @return the request
     */
    public Update update(java.lang.String circleId, com.google.api.services.plus.model.Circle content) throws java.io.IOException {
      Update result = new Update(circleId, content);
      initialize(result);
      return result;
    }

    public class Update extends PlusRequest<com.google.api.services.plus.model.Circle> {

      private static final String REST_PATH = "circles/{circleId}";

      /**
       * Update a circle's description.
       *
       * Create a request for the method "circles.update".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Update#execute()} method to invoke the remote operation. <p> {@link
       * Update#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to update.
       * @param content the {@link com.google.api.services.plus.model.Circle}
       * @since 1.13
       */
      protected Update(java.lang.String circleId, com.google.api.services.plus.model.Circle content) {
        super(Plus.this, "PUT", REST_PATH, content, com.google.api.services.plus.model.Circle.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public Update setAlt(java.lang.String alt) {
        return (Update) super.setAlt(alt);
      }

      @Override
      public Update setFields(java.lang.String fields) {
        return (Update) super.setFields(fields);
      }

      @Override
      public Update setKey(java.lang.String key) {
        return (Update) super.setKey(key);
      }

      @Override
      public Update setOauthToken(java.lang.String oauthToken) {
        return (Update) super.setOauthToken(oauthToken);
      }

      @Override
      public Update setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Update) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Update setQuotaUser(java.lang.String quotaUser) {
        return (Update) super.setQuotaUser(quotaUser);
      }

      @Override
      public Update setUserIp(java.lang.String userIp) {
        return (Update) super.setUserIp(userIp);
      }

      /** The ID of the circle to update. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to update.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to update. */
      public Update setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      @Override
      public Update set(String parameterName, Object value) {
        return (Update) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the Comments collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Plus plus = new Plus(...);}
   *   {@code Plus.Comments.List request = plus.comments().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Comments comments() {
    return new Comments();
  }

  /**
   * The "comments" collection of methods.
   */
  public class Comments {

    /**
     * Get a comment.
     *
     * Create a request for the method "comments.get".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param commentId The ID of the comment to get.
     * @return the request
     */
    public Get get(java.lang.String commentId) throws java.io.IOException {
      Get result = new Get(commentId);
      initialize(result);
      return result;
    }

    public class Get extends PlusRequest<com.google.api.services.plus.model.Comment> {

      private static final String REST_PATH = "comments/{commentId}";

      /**
       * Get a comment.
       *
       * Create a request for the method "comments.get".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param commentId The ID of the comment to get.
       * @since 1.13
       */
      protected Get(java.lang.String commentId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.Comment.class);
        this.commentId = com.google.api.client.util.Preconditions.checkNotNull(commentId, "Required parameter commentId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(java.lang.String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(java.lang.String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(java.lang.String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(java.lang.String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(java.lang.String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(java.lang.String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the comment to get. */
      @com.google.api.client.util.Key
      private java.lang.String commentId;

      /** The ID of the comment to get.
       */
      public java.lang.String getCommentId() {
        return commentId;
      }

      /** The ID of the comment to get. */
      public Get setCommentId(java.lang.String commentId) {
        this.commentId = commentId;
        return this;
      }

      @Override
      public Get set(String parameterName, Object value) {
        return (Get) super.set(parameterName, value);
      }
    }
    /**
     * Create a new comment in reply to an activity.
     *
     * Create a request for the method "comments.insert".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param activityId The ID of the activity to reply to.
     * @param content the {@link com.google.api.services.plus.model.Comment}
     * @return the request
     */
    public Insert insert(java.lang.String activityId, com.google.api.services.plus.model.Comment content) throws java.io.IOException {
      Insert result = new Insert(activityId, content);
      initialize(result);
      return result;
    }

    public class Insert extends PlusRequest<com.google.api.services.plus.model.Comment> {

      private static final String REST_PATH = "activities/{activityId}/comments";

      /**
       * Create a new comment in reply to an activity.
       *
       * Create a request for the method "comments.insert".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param activityId The ID of the activity to reply to.
       * @param content the {@link com.google.api.services.plus.model.Comment}
       * @since 1.13
       */
      protected Insert(java.lang.String activityId, com.google.api.services.plus.model.Comment content) {
        super(Plus.this, "POST", REST_PATH, content, com.google.api.services.plus.model.Comment.class);
        this.activityId = com.google.api.client.util.Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public Insert setAlt(java.lang.String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(java.lang.String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(java.lang.String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(java.lang.String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(java.lang.String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(java.lang.String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the activity to reply to. */
      @com.google.api.client.util.Key
      private java.lang.String activityId;

      /** The ID of the activity to reply to.
       */
      public java.lang.String getActivityId() {
        return activityId;
      }

      /** The ID of the activity to reply to. */
      public Insert setActivityId(java.lang.String activityId) {
        this.activityId = activityId;
        return this;
      }

      @Override
      public Insert set(String parameterName, Object value) {
        return (Insert) super.set(parameterName, value);
      }
    }
    /**
     * List all of the comments for an activity.
     *
     * Create a request for the method "comments.list".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param activityId The ID of the activity to get comments for.
     * @return the request
     */
    public List list(java.lang.String activityId) throws java.io.IOException {
      List result = new List(activityId);
      initialize(result);
      return result;
    }

    public class List extends PlusRequest<com.google.api.services.plus.model.CommentFeed> {

      private static final String REST_PATH = "activities/{activityId}/comments";

      /**
       * List all of the comments for an activity.
       *
       * Create a request for the method "comments.list".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param activityId The ID of the activity to get comments for.
       * @since 1.13
       */
      protected List(java.lang.String activityId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.CommentFeed.class);
        this.activityId = com.google.api.client.util.Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(java.lang.String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(java.lang.String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(java.lang.String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(java.lang.String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(java.lang.String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(java.lang.String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the activity to get comments for. */
      @com.google.api.client.util.Key
      private java.lang.String activityId;

      /** The ID of the activity to get comments for.
       */
      public java.lang.String getActivityId() {
        return activityId;
      }

      /** The ID of the activity to get comments for. */
      public List setActivityId(java.lang.String activityId) {
        this.activityId = activityId;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public List setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The order in which to sort the list of comments. */
      @com.google.api.client.util.Key
      private java.lang.String sortOrder;

      /** The order in which to sort the list of comments. [default: ascending]
       */
      public java.lang.String getSortOrder() {
        return sortOrder;
      }

      /** The order in which to sort the list of comments. */
      public List setSortOrder(java.lang.String sortOrder) {
        this.sortOrder = sortOrder;
        return this;
      }

      /**
       * The maximum number of comments to include in the response, which is used for paging. For
       * any response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of comments to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 20]
     [minimum: 0] [maximum: 500]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of comments to include in the response, which is used for paging. For
       * any response, the actual number returned might be less than the specified maxResults.
       */
      public List setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public List set(String parameterName, Object value) {
        return (List) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the Media collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Plus plus = new Plus(...);}
   *   {@code Plus.Media.List request = plus.media().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Media media() {
    return new Media();
  }

  /**
   * The "media" collection of methods.
   */
  public class Media {

    /**
     * Add a new media item to an album. The current upload size limitations are 36MB for a photo and
     * 1GB for a video. Uploads do not count against quota if photos are less than 2048 pixels on their
     * longest side or videos are less than 15 minutes in length.
     *
     * Create a request for the method "media.insert".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user to create the activity on behalf of.
     * @param collection
     * @param content the {@link com.google.api.services.plus.model.Media}
     * @return the request
     */
    public Insert insert(java.lang.String userId, java.lang.String collection, com.google.api.services.plus.model.Media content) throws java.io.IOException {
      Insert result = new Insert(userId, collection, content);
      initialize(result);
      return result;
    }

    /**
     * Add a new media item to an album. The current upload size limitations are 36MB for a photo and
     * 1GB for a video. Uploads do not count against quota if photos are less than 2048 pixels on their
     * longest side or videos are less than 15 minutes in length.
     *
     * Create a request for the method "media.insert".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * <p>
     * This method should be used for uploading media content.
     * </p>
     *
     * @param userId The ID of the user to create the activity on behalf of.@param collection
     * @param content the {@link com.google.api.services.plus.model.Media} media metadata or {@code null} if none
     * @param mediaContent The media HTTP content or {@code null} if none.
     * @return the request
     * @throws java.io.IOException if the initialization of the request fails
     */
    public Insert insert(java.lang.String userId, java.lang.String collection, com.google.api.services.plus.model.Media content,
        com.google.api.client.http.AbstractInputStreamContent mediaContent) throws java.io.IOException {
      Insert result = new Insert(userId, collection, content, mediaContent);
      initialize(result);
      return result;
    }

    public class Insert extends PlusRequest<com.google.api.services.plus.model.Media> {

      private static final String REST_PATH = "people/{userId}/media/{collection}";

      /**
       * Add a new media item to an album. The current upload size limitations are 36MB for a photo and
       * 1GB for a video. Uploads do not count against quota if photos are less than 2048 pixels on
       * their longest side or videos are less than 15 minutes in length.
       *
       * Create a request for the method "media.insert".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user to create the activity on behalf of.
       * @param collection
       * @param content the {@link com.google.api.services.plus.model.Media}
       * @since 1.13
       */
      protected Insert(java.lang.String userId, java.lang.String collection, com.google.api.services.plus.model.Media content) {
        super(Plus.this, "POST", REST_PATH, content, com.google.api.services.plus.model.Media.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        this.collection = com.google.api.client.util.Preconditions.checkNotNull(collection, "Required parameter collection must be specified.");
      }

      /**
       * Add a new media item to an album. The current upload size limitations are 36MB for a photo and
       * 1GB for a video. Uploads do not count against quota if photos are less than 2048 pixels on
       * their longest side or videos are less than 15 minutes in length.
       *
       * Create a request for the method "media.insert".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must
       * be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * <p>
       * This constructor should be used for uploading media content.
       * </p>
       *
       * @param userId The ID of the user to create the activity on behalf of.@param collection
       * @param content the {@link com.google.api.services.plus.model.Media} media metadata or {@code null} if none
       * @param mediaContent The media HTTP content or {@code null} if none.
       * @since 1.13
       */
      protected Insert(java.lang.String userId, java.lang.String collection, com.google.api.services.plus.model.Media content,
          com.google.api.client.http.AbstractInputStreamContent mediaContent) {
        super(Plus.this, "POST", "/upload/" + getServicePath() + REST_PATH, content, com.google.api.services.plus.model.Media.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        this.collection = com.google.api.client.util.Preconditions.checkNotNull(collection, "Required parameter collection must be specified.");
        initializeMediaUpload(mediaContent);
      }

      @Override
      public Insert setAlt(java.lang.String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(java.lang.String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(java.lang.String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(java.lang.String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(java.lang.String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(java.lang.String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the user to create the activity on behalf of. */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the user to create the activity on behalf of.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /** The ID of the user to create the activity on behalf of. */
      public Insert setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      @com.google.api.client.util.Key
      private java.lang.String collection;

      /**

       */
      public java.lang.String getCollection() {
        return collection;
      }

      public Insert setCollection(java.lang.String collection) {
        this.collection = collection;
        return this;
      }

      @Override
      public Insert set(String parameterName, Object value) {
        return (Insert) super.set(parameterName, value);
      }
    }

  }

  /**
   * An accessor for creating requests from the People collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Plus plus = new Plus(...);}
   *   {@code Plus.People.List request = plus.people().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public People people() {
    return new People();
  }

  /**
   * The "people" collection of methods.
   */
  public class People {

    /**
     * Get a person's profile.
     *
     * Create a request for the method "people.get".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the person to get the profile for. The special value "me" can be used to indicate the
     *        authenticated user.
     * @return the request
     */
    public Get get(java.lang.String userId) throws java.io.IOException {
      Get result = new Get(userId);
      initialize(result);
      return result;
    }

    public class Get extends PlusRequest<com.google.api.services.plus.model.Person> {

      private static final String REST_PATH = "people/{userId}";

      /**
       * Get a person's profile.
       *
       * Create a request for the method "people.get".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the person to get the profile for. The special value "me" can be used to indicate the
     *        authenticated user.
       * @since 1.13
       */
      protected Get(java.lang.String userId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.Person.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(java.lang.String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(java.lang.String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(java.lang.String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(java.lang.String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(java.lang.String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(java.lang.String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /**
       * The ID of the person to get the profile for. The special value "me" can be used to indicate
       * the authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** The ID of the person to get the profile for. The special value "me" can be used to indicate the
     authenticated user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * The ID of the person to get the profile for. The special value "me" can be used to indicate
       * the authenticated user.
       */
      public Get setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      @Override
      public Get set(String parameterName, Object value) {
        return (Get) super.set(parameterName, value);
      }
    }
    /**
     * List all of the people in the specified collection.
     *
     * Create a request for the method "people.list".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId Get the collection of people for the person identified. Use "me" to indicate the authenticated user.
     * @param collection The collection of people to list.
     * @return the request
     */
    public List list(java.lang.String userId, java.lang.String collection) throws java.io.IOException {
      List result = new List(userId, collection);
      initialize(result);
      return result;
    }

    public class List extends PlusRequest<com.google.api.services.plus.model.PeopleFeed> {

      private static final String REST_PATH = "people/{userId}/people/{collection}";

      /**
       * List all of the people in the specified collection.
       *
       * Create a request for the method "people.list".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)} must be
       * called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param userId Get the collection of people for the person identified. Use "me" to indicate the authenticated user.
       * @param collection The collection of people to list.
       * @since 1.13
       */
      protected List(java.lang.String userId, java.lang.String collection) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.PeopleFeed.class);
        this.userId = com.google.api.client.util.Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        this.collection = com.google.api.client.util.Preconditions.checkNotNull(collection, "Required parameter collection must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(java.lang.String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(java.lang.String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(java.lang.String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(java.lang.String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(java.lang.String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(java.lang.String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /**
       * Get the collection of people for the person identified. Use "me" to indicate the
       * authenticated user.
       */
      @com.google.api.client.util.Key
      private java.lang.String userId;

      /** Get the collection of people for the person identified. Use "me" to indicate the authenticated
     user.
       */
      public java.lang.String getUserId() {
        return userId;
      }

      /**
       * Get the collection of people for the person identified. Use "me" to indicate the
       * authenticated user.
       */
      public List setUserId(java.lang.String userId) {
        this.userId = userId;
        return this;
      }

      /** The collection of people to list. */
      @com.google.api.client.util.Key
      private java.lang.String collection;

      /** The collection of people to list.
       */
      public java.lang.String getCollection() {
        return collection;
      }

      /** The collection of people to list. */
      public List setCollection(java.lang.String collection) {
        this.collection = collection;
        return this;
      }

      /** The order to return people in. */
      @com.google.api.client.util.Key
      private java.lang.String orderBy;

      /** The order to return people in.
       */
      public java.lang.String getOrderBy() {
        return orderBy;
      }

      /** The order to return people in. */
      public List setOrderBy(java.lang.String orderBy) {
        this.orderBy = orderBy;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public List setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
       * The maximum number of people to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of people to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 100]
     [minimum: 1] [maximum: 100]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of people to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      public List setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public List set(String parameterName, Object value) {
        return (List) super.set(parameterName, value);
      }
    }
    /**
     * List all of the people in the specified collection for a particular activity.
     *
     * Create a request for the method "people.listByActivity".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link ListByActivity#execute()} method to invoke the remote operation.
     *
     * @param activityId The ID of the activity to get the list of people for.
     * @param collection The collection of people to list.
     * @return the request
     */
    public ListByActivity listByActivity(java.lang.String activityId, java.lang.String collection) throws java.io.IOException {
      ListByActivity result = new ListByActivity(activityId, collection);
      initialize(result);
      return result;
    }

    public class ListByActivity extends PlusRequest<com.google.api.services.plus.model.PeopleFeed> {

      private static final String REST_PATH = "activities/{activityId}/people/{collection}";

      /**
       * List all of the people in the specified collection for a particular activity.
       *
       * Create a request for the method "people.listByActivity".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link ListByActivity#execute()} method to invoke the remote operation.
       * <p> {@link ListByActivity#initialize(com.google.api.client.googleapis.services.AbstractGoogleCl
       * ientRequest)} must be called to initialize this instance immediately after invoking the
       * constructor. </p>
       *
       * @param activityId The ID of the activity to get the list of people for.
       * @param collection The collection of people to list.
       * @since 1.13
       */
      protected ListByActivity(java.lang.String activityId, java.lang.String collection) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.PeopleFeed.class);
        this.activityId = com.google.api.client.util.Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
        this.collection = com.google.api.client.util.Preconditions.checkNotNull(collection, "Required parameter collection must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public ListByActivity setAlt(java.lang.String alt) {
        return (ListByActivity) super.setAlt(alt);
      }

      @Override
      public ListByActivity setFields(java.lang.String fields) {
        return (ListByActivity) super.setFields(fields);
      }

      @Override
      public ListByActivity setKey(java.lang.String key) {
        return (ListByActivity) super.setKey(key);
      }

      @Override
      public ListByActivity setOauthToken(java.lang.String oauthToken) {
        return (ListByActivity) super.setOauthToken(oauthToken);
      }

      @Override
      public ListByActivity setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (ListByActivity) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public ListByActivity setQuotaUser(java.lang.String quotaUser) {
        return (ListByActivity) super.setQuotaUser(quotaUser);
      }

      @Override
      public ListByActivity setUserIp(java.lang.String userIp) {
        return (ListByActivity) super.setUserIp(userIp);
      }

      /** The ID of the activity to get the list of people for. */
      @com.google.api.client.util.Key
      private java.lang.String activityId;

      /** The ID of the activity to get the list of people for.
       */
      public java.lang.String getActivityId() {
        return activityId;
      }

      /** The ID of the activity to get the list of people for. */
      public ListByActivity setActivityId(java.lang.String activityId) {
        this.activityId = activityId;
        return this;
      }

      /** The collection of people to list. */
      @com.google.api.client.util.Key
      private java.lang.String collection;

      /** The collection of people to list.
       */
      public java.lang.String getCollection() {
        return collection;
      }

      /** The collection of people to list. */
      public ListByActivity setCollection(java.lang.String collection) {
        this.collection = collection;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public ListByActivity setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
       * The maximum number of people to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of people to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 20]
     [minimum: 1] [maximum: 100]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of people to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      public ListByActivity setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public ListByActivity set(String parameterName, Object value) {
        return (ListByActivity) super.set(parameterName, value);
      }
    }
    /**
     * List all of the people who are members of a circle.
     *
     * Create a request for the method "people.listByCircle".
     *
     * This request holds the parameters needed by the the plus server.  After setting any optional
     * parameters, call the {@link ListByCircle#execute()} method to invoke the remote operation.
     *
     * @param circleId The ID of the circle to get the members of.
     * @return the request
     */
    public ListByCircle listByCircle(java.lang.String circleId) throws java.io.IOException {
      ListByCircle result = new ListByCircle(circleId);
      initialize(result);
      return result;
    }

    public class ListByCircle extends PlusRequest<com.google.api.services.plus.model.PeopleFeed> {

      private static final String REST_PATH = "circles/{circleId}/people";

      /**
       * List all of the people who are members of a circle.
       *
       * Create a request for the method "people.listByCircle".
       *
       * This request holds the parameters needed by the the plus server.  After setting any optional
       * parameters, call the {@link ListByCircle#execute()} method to invoke the remote operation. <p>
       * {@link
       * ListByCircle#initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest)}
       * must be called to initialize this instance immediately after invoking the constructor. </p>
       *
       * @param circleId The ID of the circle to get the members of.
       * @since 1.13
       */
      protected ListByCircle(java.lang.String circleId) {
        super(Plus.this, "GET", REST_PATH, null, com.google.api.services.plus.model.PeopleFeed.class);
        this.circleId = com.google.api.client.util.Preconditions.checkNotNull(circleId, "Required parameter circleId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public ListByCircle setAlt(java.lang.String alt) {
        return (ListByCircle) super.setAlt(alt);
      }

      @Override
      public ListByCircle setFields(java.lang.String fields) {
        return (ListByCircle) super.setFields(fields);
      }

      @Override
      public ListByCircle setKey(java.lang.String key) {
        return (ListByCircle) super.setKey(key);
      }

      @Override
      public ListByCircle setOauthToken(java.lang.String oauthToken) {
        return (ListByCircle) super.setOauthToken(oauthToken);
      }

      @Override
      public ListByCircle setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (ListByCircle) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public ListByCircle setQuotaUser(java.lang.String quotaUser) {
        return (ListByCircle) super.setQuotaUser(quotaUser);
      }

      @Override
      public ListByCircle setUserIp(java.lang.String userIp) {
        return (ListByCircle) super.setUserIp(userIp);
      }

      /** The ID of the circle to get the members of. */
      @com.google.api.client.util.Key
      private java.lang.String circleId;

      /** The ID of the circle to get the members of.
       */
      public java.lang.String getCircleId() {
        return circleId;
      }

      /** The ID of the circle to get the members of. */
      public ListByCircle setCircleId(java.lang.String circleId) {
        this.circleId = circleId;
        return this;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      @com.google.api.client.util.Key
      private java.lang.String pageToken;

      /** The continuation token, which is used to page through large result sets. To get the next page of
     results, set this parameter to the value of "nextPageToken" from the previous response.
       */
      public java.lang.String getPageToken() {
        return pageToken;
      }

      /**
       * The continuation token, which is used to page through large result sets. To get the next
       * page of results, set this parameter to the value of "nextPageToken" from the previous
       * response.
       */
      public ListByCircle setPageToken(java.lang.String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
       * The maximum number of people to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      @com.google.api.client.util.Key
      private java.lang.Long maxResults;

      /** The maximum number of people to include in the response, which is used for paging. For any
     response, the actual number returned might be less than the specified maxResults. [default: 20]
     [minimum: 1] [maximum: 100]
       */
      public java.lang.Long getMaxResults() {
        return maxResults;
      }

      /**
       * The maximum number of people to include in the response, which is used for paging. For any
       * response, the actual number returned might be less than the specified maxResults.
       */
      public ListByCircle setMaxResults(java.lang.Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      @Override
      public ListByCircle set(String parameterName, Object value) {
        return (ListByCircle) super.set(parameterName, value);
      }
    }

  }

  /**
   * Builder for {@link Plus}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport, which should normally be:
     *        <ul>
     *        <li>Google App Engine:
     *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
     *        <li>Android: {@code newCompatibleTransport} from
     *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
     *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
     *        </li>
     *        </ul>
     * @param jsonFactory JSON factory, which may be:
     *        <ul>
     *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
     *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
     *        <li>Android Honeycomb or higher:
     *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
     *        </ul>
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
        com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Plus}. */
    @Override
    public Plus build() {
      return new Plus(this);
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    @Override
    public Builder setSuppressRequiredParameterChecks(boolean suppressRequiredParameterChecks) {
      return (Builder) super.setSuppressRequiredParameterChecks(suppressRequiredParameterChecks);
    }

    @Override
    public Builder setSuppressAllChecks(boolean suppressAllChecks) {
      return (Builder) super.setSuppressAllChecks(suppressAllChecks);
    }

    /**
     * Set the {@link PlusRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setPlusRequestInitializer(
        PlusRequestInitializer plusRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(plusRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        com.google.api.client.googleapis.services.GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
