/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-21 15:27:30 UTC)
 * on 2013-08-29 at 01:09:00 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.plus.model;

/**
 * Model definition for Audience.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google+ API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Audience extends com.google.api.client.json.GenericJson {

  /**
   * ETag of this response for caching purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String etag;

  /**
   * The access control list entry.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private PlusAclentryResource item;

  /**
   * Identifies this resource as an audience. Value: "plus#audience".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The circle members' visibility as chosen by the owner of the circle. This only applies for
   * items with "item.type" equals "circle". Possible values are: - "public" - Members are visible
   * to the public.  - "limited" - Members are visible to a limited audience.  - "private" - Members
   * are visible to the owner only.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String visibility;

  /**
   * ETag of this response for caching purposes.
   * @return value or {@code null} for none
   */
  public java.lang.String getEtag() {
    return etag;
  }

  /**
   * ETag of this response for caching purposes.
   * @param etag etag or {@code null} for none
   */
  public Audience setEtag(java.lang.String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * The access control list entry.
   * @return value or {@code null} for none
   */
  public PlusAclentryResource getItem() {
    return item;
  }

  /**
   * The access control list entry.
   * @param item item or {@code null} for none
   */
  public Audience setItem(PlusAclentryResource item) {
    this.item = item;
    return this;
  }

  /**
   * Identifies this resource as an audience. Value: "plus#audience".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as an audience. Value: "plus#audience".
   * @param kind kind or {@code null} for none
   */
  public Audience setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The circle members' visibility as chosen by the owner of the circle. This only applies for
   * items with "item.type" equals "circle". Possible values are: - "public" - Members are visible
   * to the public.  - "limited" - Members are visible to a limited audience.  - "private" - Members
   * are visible to the owner only.
   * @return value or {@code null} for none
   */
  public java.lang.String getVisibility() {
    return visibility;
  }

  /**
   * The circle members' visibility as chosen by the owner of the circle. This only applies for
   * items with "item.type" equals "circle". Possible values are: - "public" - Members are visible
   * to the public.  - "limited" - Members are visible to a limited audience.  - "private" - Members
   * are visible to the owner only.
   * @param visibility visibility or {@code null} for none
   */
  public Audience setVisibility(java.lang.String visibility) {
    this.visibility = visibility;
    return this;
  }

  @Override
  public Audience set(String fieldName, Object value) {
    return (Audience) super.set(fieldName, value);
  }

  @Override
  public Audience clone() {
    return (Audience) super.clone();
  }

}
